diff -u --recursive --new-file asterisk-0.5.0/callerid.c.cidform asterisk-0.5.0/callerid.c
--- asterisk-0.5.0/callerid.c.cidform	Thu Nov  6 23:57:45 2003
+++ asterisk-0.5.0/callerid.c	Thu Nov  6 23:58:40 2003
@@ -515,45 +515,47 @@
 
 int ast_callerid_parse(char *instr, char **name, char **location)
 {
-	char *ns, *ne;
-	char *ls, *le;
+	char *pname, *ne;
+	char *ploc, *le;
 	char tmp[256];
 	/* Try for "name" <location> format or 
 	   name <location> format */
-	if ((ls = strchr(instr, '<')) && (le = strchr(ls, '>'))) {
+	if ((ploc = strchr(instr, '<')) && (le = strchr(ploc, '>'))) {
 		/* Found the location */
 		*le = '\0';
-		*ls = '\0';
-		*location = ls + 1;
-		if ((ns = strchr(instr, '\"')) && (ne = strchr(ns + 1, '\"'))) {
+		*ploc++ = '\0';
+		if ((pname = strchr(instr, '\"')) && (ne = strchr(pname + 1, '\"'))) {
 			/* Get name out of quotes */
-			*ns = '\0';
+			*pname++ = '\0';
 			*ne = '\0';
-			*name = ns + 1;
-			return 0;
+			*name = pname;
 		} else {
 			/* Just trim off any trailing spaces */
-			*name = instr;
-			while(strlen(instr) && (instr[strlen(instr) - 1] < 33))
-				instr[strlen(instr) - 1] = '\0';
+			pname = instr + strlen(instr);
+			while((pname > instr) && (*--pname <= ' '))
+				*pname = '\0';
 			/* And leading spaces */
-			while(**name && (**name < 33))
-				name++;
-			return 0;
+			for(pname = instr; *pname && (*pname <= ' '); ++pname);
+			*name = pname;
 		}
+		*location = ast_isphonenumber(ploc) ? ploc : NULL;
+		return 0;
 	} else {
 		strncpy(tmp, instr, sizeof(tmp)-1);
 		ast_shrink_phone_number(tmp);
 		if (ast_isphonenumber(tmp)) {
 			/* Assume it's just a location */
 			*name = NULL;
-			*location = instr;
+			*location = instr;	/* XXX: Does ast_shrink_phone_number(instr) required? */
 		} else {
 			/* Assume it's just a name.  Make sure it's not quoted though */
-			*name = instr;
-			while(*(*name) && ((*(*name) < 33) || (*(*name) == '\"'))) (*name)++;
-			ne = *name + strlen(*name) - 1;
-			while((ne > *name) && ((*ne < 33) || (*ne == '\"'))) { *ne = '\0'; ne--; }
+			pname = instr + strlen(instr) - 1;
+			while((pname >= instr) && ((*pname <= ' ') || (*pname == '\"')))
+				*pname-- = '\0';
+			pname = instr;
+			while(*pname && ((*pname <= ' ') || (*pname == '\"')))
+				pname++;
+			*name = pname;
 			*location = NULL;
 		}
 		return 0;
